[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.33 and 1.68

version 1.33, 2021/11/19 03:13:11 version 1.68, 2021/12/11 03:56:35
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 # Fake up some things from install.sub that we don't need to actually do  set -o errexit -o pipefail -o nounset
 prefetcharea_fs_list() {  
         echo "${DESTDIR}/tmp"  
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  CFILE=SHA256.sig
   DESTDIR=${DESTDIR:-}
   FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
   
 # Create a temporary directory based on the supplied directory name prefix.  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
   HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          # If we're not in the installer,
                 ((++_i < 10000)) || return 1          # we have mktemp and a more hostile environment
         done          if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
         echo "$_dir"          echo "$_dir"
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  realpath () {
 # Take extra care that after "cmd" no "user" processes exist.          if [ -x /usr/bin/realpath ]; then
 #                  /usr/bin/realpath "$1"
 # Optionally:          elif [ "$1" = "${1%/*}" ]; then
 #       - create "file" and chown it to "user"                  echo "${PWD}/$1"
 #       - after "cmd", chown "file" back to root          else
 #                  echo "$( cd "${1%/*}" && pwd )/${1##*/}"
 # Usage: do_as user [-f file] cmd          fi
 do_as() {  }
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1  fetch() {
         shift          local _file=$1 _user=_file _exit
   
         if [[ $1 == -f ]]; then          # If we're not in the installer, we have su(1)
                 _file=$2          # and doas(1) is unlikely to be configured.
                 shift 2          if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm \
                           -o- '${FWURL}/${_file}'" > "$_file"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       ftp -D 'Get/Verify' -Vm \
                           -o- "${FWURL}/${_file}" > "$_file"
                   _exit="$?"
         fi          fi
   
         if [[ -n $_file ]]; then          if [ "$_exit" -ne 0 ]; then
                 >$_file                  rm -f "$_file"
                 chown "$_user" "$_file"                  echo "Cannot fetch $_file" >&2
                   return 1
         fi          fi
   }
   
         doas -u "$_user" "$@"  verify() {
         _rc=$?          # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 ($1) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for $1 failed." >&2
                   return 1
           fi
   }
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do  devices_needing_firmware() {
                 echo "Processes still running for user $_user after: $@"          local _d _m _grep _dmesgtail _last=''
                 sleep 1  
         done  
   
         [[ -n $_file ]] && chown root "$_file"          # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
   
         return $_rc          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
                   echo "$_dmesgtail" | $_grep -q "$_m" || continue
                   echo "$_d"
                   _last="$_d"
           done
 }  }
   
 unpriv() {  firmware_filename() {
         do_as _sndio "$@"          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
 unpriv2() {  firmware_devicename() {
         do_as _file "$@"          local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 VNAME=${VNAME:-$(sysctl -n kern.osrelease)}  installed_firmware() {
 VERSION=${VERSION:"${VNAME%.*}${VNAME#*.}"}          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
 FWDIR=${FWDIR:-$VNAME}                  [ -e "$fw" ] || continue
 MODE=${MODE:-install}                  echo "${fw##*/}"
           done
   }
   
 # TODO: We need the firmware for the system we just installed  add_firmware () {
 #       not the one we booted from.  For example:          local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release          ftp -D "Install" -Vmo- "file:${1}" |
 #         will install the firmware from the 7.0 directory instead of                  tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
 #         from the snapshots dir.                  -s ",^firmware,${DESTDIR}/etc/firmware," \
 #       If they're using sysupgrade, then the installer kernel will be correct.                  -C / -zxphf - "+*" "firmware/*"
 #       If we're doing this in the installer we can check what they picked  
 #       for downloading sets and use that value.  
 #       Otherwise, the fw_update after first boot will fix it up for us.  
   
 HTTP_FWDIR=$FWDIR          # TODO: Should we mark these so real fw_update can -Drepair?
 set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot          ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  delete_firmware() {
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 FWPATTERNS="file:${0%/*}/firmware_patterns"  
   
 # TODO: support srclocal installation of firmware somehow          # TODO: Check hash for files before deleting
 fw_update() {          echo "Uninstalling $_pkg"
         local _src=$1 _tmpfs_list _tmpfs _tmpsrc \          _cwd="${_pkgdir}/$_pkg"
                 _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \  
                 _f _r _remove _i _installed  
         local _srclocal=false _unpriv=unpriv  
   
         echo "Let's $MODE firmware!"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
         local _d _drivers=$(  
                 last=''  
                 $_unpriv ftp -D "Detecting" -Vmo- $FWPATTERNS |  
                 while read _d _m; do  
                         grep=grep  
                         [ "$last" = "$_d" ] && continue  
                         [ "$_m" ] || _m="^$_d[0-9][0-9]* at "  
                         [ "$_m" = "${_m#^}" ] && grep=fgrep  
                         $grep -q "$_m" /var/run/dmesg.boot || continue  
                         echo $_d  
                         last=$_d  
                 done  
         )  
   
         if [ -z "$_drivers" ]; then          while read -r c g; do
                 echo "No devices found which need firmware files to be downloaded."                  case $c in
                 return                  @cwd) _cwd="${DESTDIR}$g"
         fi                    ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
         ! _tmpfs_list=$(prefetcharea_fs_list) &&          # We specifically rm -f here because not removing files/dirs
                 echo "Cannot determine prefetch area" >&2 && return          # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
         for _tmpfs in $_tmpfs_list; do                  if [ -d "$_r" ]; then
                 # Try to clean up from previous runs, assuming                          # Try hard not to actually remove recursively
                 # the _tmpfs selection yields the same mount                          # without rmdir on the install media.
                 # point.                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                 for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do                  else
                         [[ -d $_tmpsrc ]] && rm -r $_tmpsrc                          rm -f "$_r"
                 done  
   
                 # Create a download directory for the firmware and  
                 # check that the _sndio user can read files from  
                 # it. Otherwise cleanup and skip the filesystem.  
                 if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then  
                         (  
                         >$_tmpsrc/t &&  
                         $_unpriv cat $_tmpsrc/t  
                         ) >/dev/null 2>&1 && break ||  
                                 rm -r $_tmpsrc  
                 fi                  fi
         done          done
   }
   
         [[ ! -d $_tmpsrc ]] &&  usage() {
                 echo "Cannot create prefetch area" >&2 && return 1          echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
           exit 2
   }
   
         # Cleanup from previous runs.  INSTALL=true
         rm -f $_cfile $_cfile.sig  DOWNLOAD=true
   LOCALDIR=false
   
         _t=Get/Verify  while getopts dL name
   do
          case "$name" in
          # "download only" means local dir and don't install
          d) LOCALDIR=true INSTALL=false ;;
          L) LOCALDIR=true ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&  # If we're installing from a local dir
             echo "Cannot fetch SHA256.sig" >&2 && return 1  # we don't want to download anything
   "$LOCALDIR" && "$INSTALL" && DOWNLOAD=false
   
         # Verify signature file with public keys.  set -A devices -- "$@"
         ! $_unpriv -f "$_cfile" \  
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&  
             echo "Signature check of SHA256.sig failed" >&2 && return 1  
   
         for _d in $_drivers; do  [ "${devices[*]:-}" ] ||
                 _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )      set -A devices -- $( devices_needing_firmware )
                 _installed=$(  
                 for fw in "${_pkgdir}/$_d-firmware"*; do  
                         [ -e "$fw" ] || continue  
                         echo ${fw##*/}  
                 done  
                 )  
   
                 for _i in $_installed; do  if [ ! "${devices[*]:-}" ]; then
                         if [ "$_f" = "$_i.tgz" ]; then          echo "No devices found which need firmware files to be downloaded."
                                 echo "$_i already installed"          exit
                                 continue 2  fi
                         fi  
                 done  
   
                 rm -f /tmp/h /tmp/fail  # Have to find the full path to firmware files
   # so we can cd and still find them later.
   i=0
   while (( i < "${#devices[@]}" )); do
           f="${devices[$i]}"
           d=$( firmware_devicename "$f" )
           if [ -e "$f" ]; then
                   if "$DOWNLOAD"; then
                           echo "Cannot download local file $f" >&2
                           exit 2
                   fi
                   devices[$i]="$d:$( realpath "$f" )"
           fi
           i=$((i + 1))
   done
   
                 # Fetch firmware file and create a checksum by piping through  if ! "$LOCALDIR"; then
                 # sha256. Create a flag file in case ftp failed. Firmware          cd "$( tmpdir "${DESTDIR}/tmp/fw_install" )"
                 # from net is written to the prefetch area.  fi
                 ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |  
                 ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||  
                     unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )  
   
                 # Handle failed transfer.  if "$DOWNLOAD" && ! [[ -e "$CFILE" ]]; then
                 if [[ -f /tmp/fail ]]; then          fetch "$CFILE"
                         rm -f "$_tmpsrc/$_f"          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                         echo "Fetching of $_f failed!" >&2              echo "Signature check of SHA256.sig failed" >&2 && exit 1
                         continue  fi
                 fi  
   
                 # Verify firmware by comparing its checksum with SHA256.  for d in "${devices[@]}"; do
                 if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then          f="${d##*:}"
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"          if [ "$f" = "$d" ]; then
                         echo "Checksum test for $_f failed." >&2                  f=$( firmware_filename "$d" || true )
                         continue                  [ "$f" ] || continue
                 fi          else
                   d="${d%:*}"
           fi
   
                 # TODO: Check hash for files before deleting          set -A installed -- $( installed_firmware "$d" )
                 if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then  
                         echo "Uninstalling $_installed"  
                         cwd=${_pkgdir}/$_installed  
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           if [ "${f##*/}" = "$i.tgz" ]; then
                                   echo "$i already installed"
                                   continue 2
                           fi
                   done
           fi
   
                         while read c g; do          if [ ! -e "$f" ]; then
                                 case $c in                  "$INSTALL" && ! "$DOWNLOAD" &&
                                 @cwd) cwd="${DESTDIR}/$g"                      echo "Cannot install $f, not found" >&2 && continue
                                   ;;                  fetch  "$f" || continue
                                 @*) continue                  verify "$f" || continue
                                   ;;          elif $DOWNLOAD; then
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"                  echo "Already have $f"
                                   ;;                  verify "$f" || continue
                                 esac          fi
                         done < "${_pkgdir}/$_installed/+CONTENTS"  
   
                         # We specifically rm -f here because not removing files/dirs          "$INSTALL" || continue
                         # is probably not worth failing over.  
                         for _r in "${_remove[@]}" ; do  
                                 if [ -d "$_r" ]; then  
                                         # Try hard not to actually remove recursively  
                                         # without rmdir on the install media.  
                                         [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"  
                                 else  
                                         rm -f "$_r"  
                                 fi  
                         done  
                 fi  
   
                 # TODO: Should we mark these so real fw_update can -Drepair?          if [ "${installed[*]:-}" ]; then
                 ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |                  for i in "${installed[@]}"; do
                         tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                          delete_firmware "$i"
                         -s ",^firmware,${DESTDIR}/etc/firmware," \                  done
                         -C / -zxphf - "+*" "firmware/*"          fi
   
                 ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          add_firmware "$f"
 /^@comment pkgpath/ -1a  done
 @option manual-installation  
 @option firmware  
 @comment install-script  
 .  
 w  
 EOL  
         done  
 }  
   
 fw_update "$FWURL"  

Legend:
Removed from v.1.33  
changed lines
  Added in v.1.68

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>